%{
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <stddef.h>
#include <ctype.h>

extern int yylineno;

int yylex(void);
FILE * yyin;
FILE * yyout;
char * yytext;
void yyerror(const char *);

extern FILE *yyin;
extern int yylex();
char file[255];

int c;
int win =0;
int errors = 0;

void showError(const char y[],int x){
       char temp[15];
       char temp2[5];
       char final[256];
	   errors++;
       sprintf(temp2,"%d: ",x);
       strcpy(temp, "Line ");
       strcat(temp,temp2);
       strcpy(final,"");
       strcat(final,temp);
       strcat(final,y);
       printf("%d | %s\n",errors,final);
       
   }
   


%}

%token DIR ERR 
%token S
%token E
%token SE
%token NE
%token N
%token W
%token SW
%token NW
%token END 0 

%%



start: a
;

a: {win =0;} 
  |S b
  |E f
  |N a
  |SE g 
  |NE a
  |W  a
  |SW a
  |NW a
  
  ;

b: {win =0;} 
	|S c
	|SE d
	|NE f
	|N a
	|NW b 
	|SW b 
	|W b
	|E g 

	
	;

d: {win =0;} 	
|W c
	| E end 
	| NE i
	| NW b
        |S d
        |N g
        |SE d
        | SW d
	
	;


c:  { printf("Perdu");
	win=0;}
|N {printf("vous etes rentrée dans le mur"); exit(1);}
|E { printf("vous etes rentrée dans le mur" );exit(1);}
|NE { printf("vous etes rentrée dans le mur"); exit(1);}
|S { printf("vous etes rentrée dans le mur"); exit(1);}
|SE { printf("vous etes rentrée dans le mur"); exit(1);}
|NW { printf("vous etes rentrée dans le mur" );exit(1);}
|W { printf("vous etes rentrée dans le mur"); exit(1);};



f: {win =0;} 	
|E h
	| W a
	| SE i
	| SW b
        |N f 
	|S g
	|NE f
	|NW f
	
	;

i: {win =0;}	
|S end 
	|N h
	|NW f
	|SW d
	|E i
	|NE i
	|SE i
	|W g
	
	;

h: { printf("Perdu");
	win=0;}
|N {printf("vous etes rentrée dans le mur"); exit(1);}
|E { printf("vous etes rentrée dans le mur" );exit(1);}
|NE { printf("vous etes rentrée dans le mur"); exit(1);}
|S { printf("vous etes rentrée dans le mur"); exit(1);}
|SE { printf("vous etes rentrée dans le mur"); exit(1);}
|NW { printf("vous etes rentrée dans le mur" );exit(1);}
|W { printf("vous etes rentrée dans le mur"); exit(1);};



g: { printf("Perdu");
	win=0;}
|N {printf("vous etes rentrée dans le mur"); exit(1);}
|E { printf("vous etes rentrée dans le mur" );exit(1);}
|NE { printf("vous etes rentrée dans le mur"); exit(1);}
|S { printf("vous etes rentrée dans le mur"); exit(1);}
|SE { printf("vous etes rentrée dans le mur"); exit(1);}
|NW { printf("vous etes rentrée dans le mur" );exit(1);}
|W { printf("vous etes rentrée dans le mur"); exit(1);};


end: END {win=1; };

%%
void yyerror(const char* mess){
fprintf(stderr," %s:%i:syntaxe error (near %s) \n", file,yylineno,yytext);
exit(1);}


int main(int argc, char *argv[]){
 
  
    if (argc==2) {
        FILE *fp = fopen(argv[1],"r");
        if (fp!=NULL) {
	    strcpy(file,argv[1]);
            //printf("Reading input from file succeded: %s\n",argv[1]);
            //printf("Attention si vous aller taper une direction invalide vous n'aller pas bouger");
            yyin = fp;
           
        } else {
            printf("File doesn't exist\n");
            return 1;
        }
    } 
 yyparse();
if (win ==0)
{
printf("perdu");
}
else printf ("gagné");
    return 0;
}


